<template>
  <div>
    <div class="font-weight-medium" @click="toggleVisibility">
      <span v-if="value.length === 0" style="color: grey">
        <v-icon>mdi-chevron-right</v-icon>
        {{ $t(title) }}
      </span>
      <span v-else style="cursor: pointer">
        <v-icon v-if="isVisible">mdi-chevron-down</v-icon>
        <v-icon v-else>mdi-chevron-right</v-icon>
        {{ $t(title) }}
      </span>
    </div>
    <template v-if="isVisible">
      <v-list
        v-for="(item, index) in value"
        :key="index"
        two-line
        style="overflow-x: auto; max-height: 28rem"
        class="mx-4"
      >
        <v-list-item
          style="background-color: #f5f5f5; height: 100px; border-radius: 5px"
        >
          <div v-if="item.mimeType.startsWith(`image/`)" class="mr-4 mt-2 mb-2">
            <v-img
              max-height="80"
              max-width="80"
              :src="`data:${item.mimeType};base64,${item.dataBase64}`"
            ></v-img>
          </div>
          <v-list-item-avatar v-else width="80">
            <v-icon style="font-size: 40px">{{
              getFileIcon(item.fileName)
            }}</v-icon>
          </v-list-item-avatar>
          <v-list-item-content>
            <v-list-item-title
              ><a
                @click.prevent="
                  downloadFile(
                    `data:${item.mimeType};base64,${item.dataBase64}`,
                    item.fileName
                  )
                "
                >{{ item.fileName }}</a
              ></v-list-item-title
            >
            <v-list-item-subtitle>
              {{ item.mimeType }}
            </v-list-item-subtitle>
          </v-list-item-content>
        </v-list-item>
      </v-list>
    </template>
  </div>
</template>

<script>
import { downloadFile, getFileIcon } from "assets/util/general";

export default {
  name: "GFileList",
  props: {
    value: Array,
    title: String,
  },
  data() {
    return {
      isVisible: true,
    };
  },
  methods: {
    toggleVisibility() {
      this.isVisible = !this.isVisible;
    },
    getFileIcon(fileName) {
      return getFileIcon(fileName);
    },
    downloadFile(item, fileName) {
      downloadFile(item, fileName);
    },
  },
};
</script>
